import multiprocessing as mp
import subprocess
import time

MAX_ITER_NUM = 2
is_exit = False

def write_assert():
    with open('assert.txt', "a+") as f:
        f.write("Assert Occurred.\n")
        
def server_run():
    try:
        subprocess.check_output(["sh", "server.sh"])
    except subprocess.CalledProcessError as e:
        exit_status = e.returncode
        if exit_status == 1:
            pass
        else:
            write_assert()
    except AssertionError:
        write_assert()
        pass
            

def client_run(is_recovery):
    #waiting for server opening
    time.sleep(5)
    if(is_recovery == False):
        subprocess.run(["sh", "random_test.sh", "1"])
    else:
        subprocess.run(["sh", "random_test.sh"])
    
def main_test():
    subprocess.run(["rm", "-rf", "testdb"], shell=False)
    is_recovery = False
    for i in range(2):
        server_process = mp.Process(target=server_run, args=())
        client_process = mp.Process(target=client_run, args=(is_recovery, ))
        server_process.start()
        client_process.start()
        client_process.join()   
        server_process.join()
        if(is_recovery == False):
            is_recovery = True


if __name__ == "__main__":
    for i in range(MAX_ITER_NUM):
        main_test()